#include "Global.h"


BOOL mainInit() {
	//int  YMPTempExist = 0;
	
	// 񏉊
	memset(readBuf3               , 0, sizeof(readBuf3               ));
	memset(readBuf4               , 0, sizeof(readBuf4               ));
	memset(readBuf5               , 0, sizeof(readBuf5               ));
	memset(readBuf6               , 0, sizeof(readBuf6               ));
	memset(readBuf7               , 0, sizeof(readBuf7               ));
	memset(eff_midiAddr           , 0, sizeof(eff_midiAddr           ));
	memset(eff_midiDir            , 0, sizeof(eff_midiDir            ));
	memset(eff_midiDir_old        , 0, sizeof(eff_midiDir_old        ));
	memset(ogg_sigAddr            , 0, sizeof(ogg_sigAddr            ));
	memset(bgmStr                 , 0, sizeof(bgmStr                 ));
	memset(bgmStr_old             , 0, sizeof(bgmStr_old             ));
	memset(playedBgmStr           , 0, sizeof(playedBgmStr           ));
	memset(oggBgmStr              , 0, sizeof(oggBgmStr              ));
	memset(oggBgmStr_old          , 0, sizeof(oggBgmStr_old          ));
	memset(playedOggBgmStr        , 0, sizeof(playedOggBgmStr        ));
	memset(midiPlayerStatusAddr   , 0, sizeof(midiPlayerStatusAddr   ));
	memset(defaultTonyuprjFileAddr, 0, sizeof(defaultTonyuprjFileAddr));
	memset(usrFolderAddr          , 0, sizeof(usrFolderAddr          ));
	memset(midiFileAddrList       , 0, sizeof(midiFileAddrList       ));
	
	// vbgtH[擾i9xn NTnHj
	osPlatformId = getPlatformId();
	
	// pX߂
	memset(crDir, 0, sizeof(crDir));
	GetCurrentDirectory(sizeof(crDir), crDir);
	
	// YellowMusicPlayer̐ݒǂݍ
	memset(playerExeName, 0, sizeof(playerExeName));
	setMidiPlayerConfig(".\\Usr\\files\\YMPConfig.txt", osPlatformId, playerExeName, sizeof(playerExeName));
	
	// ł邱ƂTonyuɒm点t@C쐬(YellowMusicPlayer[h̎̂)
	if (playerMode == 0) createPreparationFile();
	
	// TonyuvZX̐mF邩f
	processCheckingInit(crDir, osPlatformId, &dwProcessId, &processCheckFlag, playerExeName, sizeof(playerExeName));
	
	// Midi֌W̏
	if (!playerInit(playerDirectMusicMode)) {
		PostMessage(hWnd, WM_CLOSE, 0, 0); // ɎsI
		return FALSE;
	}
	midiPlayerOK = 1;
	
	// DirectSound
	if (!createDS(&pDS8, hWnd)) {
		PostMessage(hWnd, WM_CLOSE, 0, 0); // ɎsI
		return FALSE;
	}
	
	// Ƃ肠ݒƂāA^Cł̏ꍇ̃AhXݒ肷
	if (strlen(crDir) + strlen("\\Usr\\files\\YMPStatus.dat") < sizeof(defaultTonyuprjFileAddr)) {
		memcpy(usrFolderAddr, crDir, strlen(crDir));                           // 
		strcat(usrFolderAddr, "\\Usr");                                        // Player.exẽfBNg/Usr
		
		memcpy(defaultTonyuprjFileAddr, crDir, strlen(crDir));                 // 
		strcat(defaultTonyuprjFileAddr, "\\Usr\\default.tonyuprj");            // Player.exẽfBNg/Usr/default.tonyuprj
		
		memcpy(eff_midiDir, crDir, strlen(crDir));                             // 
		strcat(eff_midiDir, "\\Usr\\files");                                   // Player.exẽfBNg/Usr/files
		memcpy(eff_midiDir_old, eff_midiDir, sizeof(eff_midiDir_old));         // XVOƍXV̔f邽߂ɕKvȂ̃obt@
		
		memcpy(eff_midiAddr, crDir, strlen(crDir));                            // 
		strcat(eff_midiAddr, "\\Usr\\files\\eff_midi.txt");                    // Player.exẽfBNg/Usr/files/eff_midi.txt
		
		memcpy(ogg_sigAddr, crDir, strlen(crDir));                             // 
		if (playerMode != 3) strcat(ogg_sigAddr, "\\Usr\\files\\ogg_sig.dat"); // Player.exẽfBNg/Usr/files/ogg_sig.dat
		else                 strcat(ogg_sigAddr, "\\Usr\\files\\temp.txt");    // Player.exẽfBNg/Usr/files/temp.txt
		
		memcpy(midiPlayerStatusAddr, crDir, strlen(crDir));                    // 
		strcat(midiPlayerStatusAddr, "\\Usr\\files\\YMPStatus.dat");           // Player.exẽfBNg/Usr/files/YMPStatus.dat
		
		memcpy(YMPPreparationAddr, crDir, strlen(crDir));                      // 
		strcat(YMPPreparationAddr, "\\Usr\\files\\YMPPreparation.dat");        // Player.exẽfBNg/Usr/files/YMPPreparation.dat
		
		
		
	}
	if (PathFileExists(eff_midiAddr)) {
		// Midit@Cɓǂݍł
		beforeReadMidi(usrFolderAddr, defaultTonyuprjFileAddr, midiFileAddrList, &midiFileAddrListLength);
		midiEffectFlag = 1;
	}
	
	// DirectMusic[h̏ꍇADlstH_Dlst@C邩ׂ
	// ǂݍ
	if (playerDirectMusicMode) {
		readMidiDls();
	}
	
	// ł邱ƂTonyuɒm点t@C
	deletePreparationFile();
	
	return TRUE;
}


// Eeff_midi.txt̃fBNgςɌĂяo
void initMidiParam() {
	
	midiGettingPlayerStatus = 0;
	
	midiVolume      = 0;
	midiTempo       = 1.0;
	midiPitch       = 0;
	
	midiFadeInTime  = 0;
	if (playerMode == 2) midiFadeOutTime = 1000; // MidiOggPlayer[h1000
	else                 midiFadeOutTime =    0; // ȊÕ[h0
	midiKeyShift    = 0;
	midiStartTick   = 0;
	
	midiSkipBeginning = 1;
	if (playerMode == 1) midiSkipEnding = 1; // TonyuMidiLitest[h̓XLbv
	else                 midiSkipEnding = 0; // ȊÕ[h̓XLbvȂ
	midiMasterPitch   = 0; midiPlayingMasterPitch = 0;
	midiNormalize     = 0;
	midiExclusive     = 0;
	
	GGS4SetMasterTempo(midiTempo);
	GGS4SetMasterVolume(midiVolume);
	GGS4SetMasterPitch(midiPitch);
}


void createPreparationFile() {
	HANDLE   hFile;
	
	// ł邱ƂTonyuɒm点
	hFile = CreateFile(".\\Usr\\files\\YMPPreparation.dat", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile != INVALID_HANDLE_VALUE) {
		CloseHandle(hFile);
	}
	return ;
}


void deletePreparationFile() {
	int i;
	for (i = 0; i < 10; i++) {
		DeleteFile(".\\Usr\\files\\YMPPreparation.dat");
		if (!PathFileExists(".\\Usr\\files\\YMPPreparation.dat")) break ;
		Sleep(15);
	}
	return ;
}


// OŠn擾
DWORD getPlatformId() {
	OSVERSIONINFO osInfo;
	
	osInfo.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
	GetVersionEx(&osInfo);
	
	return osInfo.dwPlatformId;
}


BOOL processCheckingInit(char *crDir, DWORD osPlatformId, DWORD *pDwProcessId, BOOL *pProcessCheckFlag, char *playerExeName, size_t playerExeNameSize) {
	TCHAR crDirExe[FILEPATH_SIZE];
	
	*pProcessCheckFlag = 1;
	
	if (!GetModuleFileNameExA) {
		if (osPlatformId != 1) {
			// NTnȂDLLǂݍ
			GetModuleFileNameExA = GetProcAddress(LoadLibrary("psapi.DLL") , "GetModuleFileNameExA");
			if (GetModuleFileNameExA == NULL) { // DLLǂݍ߂Ȃ
				*pProcessCheckFlag = 0;
				return FALSE;
			}
		}
	}
	
	memset(crDirExe, 0, sizeof(crDirExe));
	
	if (playerExeName[0] != '\0') {
		// XXXXXX.exevZX邩H
		memcpy(crDirExe, crDir, sizeof(crDirExe)-1);
		if (lstrlen(crDirExe) + strlen("\\") + strlen(playerExeName) < sizeof(crDirExe)) { strcat(crDirExe, "\\"); strcat(crDirExe, playerExeName); }
		*pDwProcessId = searchProcess(crDirExe, osPlatformId);
		// XXXXXX.exe΃pXۑďI
		if (*pDwProcessId != (DWORD)0 && *pDwProcessId != (DWORD)0xFFFFFFFF) {
			if ((unsigned int)lstrlen(crDirExe) < playerExeNameSize) memcpy(playerExeName, crDirExe, lstrlen(crDirExe));
			goto methodLabel;
		}
	}
	
	// Player.exevZX邩H
	memcpy(crDirExe, crDir, sizeof(crDirExe)-1);
	if (lstrlen(crDirExe) + strlen("\\Player.exe") < sizeof(crDirExe)) strcat(crDirExe, "\\Player.exe");
	*pDwProcessId = searchProcess(crDirExe, osPlatformId);
	// Player.exeI
	if (*pDwProcessId != (DWORD)0 && *pDwProcessId != (DWORD)0xFFFFFFFF) {
		if ((unsigned int)lstrlen(crDirExe) < playerExeNameSize) memcpy(playerExeName, crDirExe, lstrlen(crDirExe));
		goto methodLabel;
	}
	
	// Tonyu.exevZX邩H
	memcpy(crDirExe, crDir, sizeof(crDirExe)-1);
	if (lstrlen(crDirExe) + strlen("\\Tonyu.exe") < sizeof(crDirExe)) strcat(crDirExe, "\\Tonyu.exe");
	*pDwProcessId = searchProcess(crDirExe, osPlatformId);
	if (*pDwProcessId != (DWORD)0 && *pDwProcessId != (DWORD)0xFFFFFFFF) {
		if ((unsigned int)lstrlen(crDirExe) < playerExeNameSize) memcpy(playerExeName, crDirExe, lstrlen(crDirExe));
		goto methodLabel;
	}
	
	// vZXȂorG[
	*pProcessCheckFlag = 0; // vZX`FbNOFF
	
	methodLabel:
		;
	return TRUE;
}



BOOL playerInit(int DirectMusicOn) {
	GGSERROR errorFlag;
	char     tempStr[BUF_SIZE_S];
	static   SYSTEMTIME stTime;
	int      value;
	DWORD    fileReadSize;
	
	writeFile_C(".\\Kernel\\sig", "", 0, 1);
	if (playerMode == 0) writeFile_C(".\\Usr\\files\\ogg_sig.dat", "", 0, 1);
	
	if (playerMode == 2) { // MidiOggPlayer[h̏ݒ
		writeFile_C(".\\Usr\\files\\midi_sig.dat", "0", 1, 1);
		writeFile_C(".\\Usr\\files\\ogg_sig.dat", "0", 1, 1);
		
		GetLocalTime(&stTime);
		sprintf(tempStr, "%d\r\n%d\r\n%d\r\n%d\r\n%d\r\n%d",
		        stTime.wYear, stTime.wMonth, stTime.wDay,
		        stTime.wHour, stTime.wMinute, stTime.wSecond);
		writeFile_C(".\\Usr\\files\\realtime.dat", tempStr, strlen(tempStr), 1);
	}
	if (playerMode == 3) {
		writeFile_C(".\\Usr\\files\\temp.txt", "0", 1, 1);
		
		fileReadSize = readFile_C(".\\Usr\\files\\loop.txt", tempStr, 64, 0);
		if (fileReadSize > 0) {
			value = strToInt(tempStr, 0, fileReadSize, -9999);
			if (value != -9999) {
				ogg3LoopFlag = !!value;
			}
		}
		fileReadSize = readFile_C(".\\Usr\\files\\volume.txt", tempStr, 64, 0);
		if (fileReadSize > 0) {
			value = strToInt(tempStr, 0, fileReadSize, -9999);
			if (value != -9999) {
				if (value <     0) value =     0;
				if (value > 10000) value = 10000;
				ogg3Volume = (int)( (double)(value * 127 / 10000) + 0.5);
				oggVolume  = ogg3Volume;
				if (ogg3Volume <   0) ogg3Volume =   0;
				if (ogg3Volume > 127) ogg3Volume = 127;
			}
		}
		fileReadSize = readFile_C(".\\Usr\\files\\fade_s.txt", tempStr, 64, 0);
		if (fileReadSize > 0) {
			value = strToInt(tempStr, 0, fileReadSize, -9999);
			if (value != -9999) {
				if (value <     0) value =     0;
				if (value > 10000) value = 10000;
				ogg3FadeOutTime = 10000 * 250 / value;
				oggFadeOutTime  = ogg3FadeOutTime;
			}
		}
		
	}
	
	if (DirectMusicOn) errorFlag = GGS4OpenDevice(GGSDEVICE_DIRECTMUSIC, hWnd); // DirectMusic
	else               errorFlag = GGS4OpenDevice(-1, hWnd);                    // MIDI_MAPPER
	if (errorFlag != GGSERROR_NOERROR) {
		return FALSE;
	}
	
	// Midip[^
	initMidiParam();
	
	return TRUE;
}


void beforeReadMidi(char *usrFolderAddr, char *defaultTonyuprjFileAddr, char **midiFileAddrList, int *pMidiFileAddrListLength) {
	char readBuf[BUF_SIZE_L];
	char midiAddr[FILEPATH_SIZE];    // Usr猩midit@C̃AhX
	char midiAbsAddr[FILEPATH_SIZE]; // ΃AhX
	char *pBgmTagBegin;
	char *pBgmTagEnd;
	char *pTemp, *pTempR;
	int  i;
	BOOL readError = 0;
	GGSERROR errorFlag;
	DWORD fileReadSize;
	
	for (i = 0; i < 30; i++) {
		fileReadSize = readFile_C(defaultTonyuprjFileAddr, readBuf, sizeof(readBuf) - 1, 1);
		if (fileReadSize > 0) break;
		Sleep(15);
	}
	if (fileReadSize == 0) return ;
	
	// midiFileAddrList
	for (i = 0; i < 255; i++) {
		if (midiFileAddrList[i]) { // |C^LȂ
			free(midiFileAddrList[i]); // 
		}
		midiFileAddrList[i] = 0; // |C^0ɂ
	}
	*pMidiFileAddrListLength = 0;
	
	GGS4ClearList(); // GGS4̃Xg̓eS
	
	pTemp = readBuf;
	while (TRUE) {
		pTempR = strstr(pTemp, "<BGM name=\"");
		if (pTempR == NULL) break;
		pTemp = pTempR + 11;
		
		pTempR = strstr(pTemp, "\" ");
		if (pTempR == NULL) break;
		pTemp = pTempR + 2;
		
		pTempR = strstr(pTemp, "src=\"");
		if (pTempR == NULL) break;
		pTemp = pTempR + 5;
		pBgmTagBegin = pTemp;
		
		pTempR = strstr(pBgmTagBegin, "\"/>");
		if (pTempR == NULL) break;
		pBgmTagEnd = pTempR;
		pTemp = pTempR + 3;
		
		// midit@C̃AhX擾
		memset(midiAbsAddr, 0, sizeof(midiAbsAddr));
		memset(midiAddr, 0, sizeof(midiAddr));
		if (pBgmTagEnd - pBgmTagBegin < sizeof(midiAddr)) memcpy(midiAddr, pBgmTagBegin, pBgmTagEnd - pBgmTagBegin); else readError = 1;
		
		// ΃pX΃pXɕϊ (: C:\Users\makkii\Desktop\Game\Usr\ + bgm1.mid)
		if (strlen(usrFolderAddr)                   < sizeof(midiAbsAddr)) memcpy(midiAbsAddr, usrFolderAddr, strlen(usrFolderAddr)); else readError = 1;
		if (strlen(midiAbsAddr) + strlen("\\")      < sizeof(midiAbsAddr)) strcat(midiAbsAddr, "\\");                                 else readError = 1;
		if (strlen(midiAbsAddr) + strlen(midiAddr)  < sizeof(midiAbsAddr)) strcat(midiAbsAddr, midiAddr);                             else readError = 1;
		
		if (readError == 0) {
			
			// midit@Cǂݍł(Ďs3)
			if (playerCacheMode != 0) { // LbVL̂Ƃ
				for (i = 3; i > 0; i--) {
					errorFlag = GGS4AddListFromFileA(midiAbsAddr, GGSLOAD_BUFFERED*1, *pMidiFileAddrListLength);
					if (errorFlag == 0) break ;
					Sleep(15);
				}
			}
			
			if (i > 0) { // midit@C̓ǂݍ݂ɐꍇ
				// midit@CAhXXgɁAmidi̐΃AhXo^
				midiFileAddrList[*pMidiFileAddrListLength] = (char *)malloc(sizeof(char) * strlen(midiAbsAddr) + 1); // m
				if (midiFileAddrList[*pMidiFileAddrListLength] == NULL) exit(-1); // mێs  I
				memset(midiFileAddrList[*pMidiFileAddrListLength], 0, strlen(midiAbsAddr) + 1);
				memcpy(midiFileAddrList[*pMidiFileAddrListLength], midiAbsAddr, strlen(midiAbsAddr));
				
				(*pMidiFileAddrListLength) ++;
				if (*pMidiFileAddrListLength >= 255) break;
			}
		}
		readError = 0;
	}
	
	return ;
}


BOOL setEffectFileAddr(char *bgmStr, 
                       char *eff_midiAddr           , size_t eff_midiAddrSize,
                       char *eff_midiDir            , size_t eff_midiDirSize,
                       char *ogg_sigAddr            , size_t ogg_sigAddrSize,
                       char *defaultTonyuprjFileAddr, size_t defaultTonyuprjFileAddrSize,
                       char *usrFolderAddr          , size_t usrFolderAddrSize,
                       char *midiPlayerStatusAddr   , size_t midiPlayerStatusAddrSize,
                       char *YMPPreparationAddr     , size_t YMPPreparationAddrSize
                       ) {
	int i, len;
	int sc = 1;
	
	if (bgmStr[0] == '\0') return FALSE;
	
	len = strlen(bgmStr);
	for (i = len - 1; i >= 0; i--) {
		if (bgmStr[i] == '\\') {
			// default.tonyuprj ͂ǂ̃vWFNgɂ݂̂ŁA
			// ̃t@C΁Aeff_midiAddr ̗Lɂ킩
			
			// defaultTonyuprjFileAddr
			memset(defaultTonyuprjFileAddr, 0, defaultTonyuprjFileAddrSize);
			if (i + strlen("\\default.tonyuprj") >= defaultTonyuprjFileAddrSize) break ;
			memcpy(defaultTonyuprjFileAddr, bgmStr, i);
			strcat(defaultTonyuprjFileAddr, "\\default.tonyuprj");
			
			if (PathFileExists(defaultTonyuprjFileAddr)) { // default.tonyuprj ꍇ
				
				// usrFolderAddr̓eςĂȂsȂ
				if (memcmp(bgmStr, usrFolderAddr, i) == 0) return TRUE;
				
				// usrFolderAddr
				memset(usrFolderAddr, 0, usrFolderAddrSize);
				memcpy(usrFolderAddr, bgmStr, i);
				
				// midiPlayerStatusAddr
				memset(midiPlayerStatusAddr, 0, midiPlayerStatusAddrSize);
				if (strlen(usrFolderAddr) + strlen("\\files\\YMPStatus.dat")>= midiPlayerStatusAddrSize) break ;
				memcpy(midiPlayerStatusAddr, usrFolderAddr, strlen(usrFolderAddr));
				strcat(midiPlayerStatusAddr, "\\files\\YMPStatus.dat");
				
				// eff_midiAddr
				memset(eff_midiAddr, 0, eff_midiAddrSize);
				if (i + strlen("\\files\\eff_midi.txt") >= eff_midiAddrSize) break ;
				memcpy(eff_midiAddr, bgmStr, i);
				strcat(eff_midiAddr, "\\files\\eff_midi.txt");
				
				// ogg_sigAddr
				memset(ogg_sigAddr, 0, ogg_sigAddrSize);
				if (playerMode != 3) {
					if (i + strlen("\\files\\ogg_sig.dat") >= ogg_sigAddrSize) break ;
					memcpy(ogg_sigAddr, bgmStr, i);
					strcat(ogg_sigAddr, "\\files\\ogg_sig.dat");
				} else {
					if (i + strlen("\\files\\temp.txt") >= ogg_sigAddrSize) break ;
					memcpy(ogg_sigAddr, bgmStr, i);
					strcat(ogg_sigAddr, "\\files\\temp.txt");
				}
				
				// YMPPreparationAddr
				memset(YMPPreparationAddr, 0, YMPPreparationAddrSize);
				if (i + strlen("\\files\\YMPPreparation.dat") >= YMPPreparationAddrSize) break ;
				memcpy(YMPPreparationAddr, bgmStr, i);
				strcat(YMPPreparationAddr, "\\files\\YMPPreparation.dat");
				
				
				if (PathFileExists(eff_midiAddr)) { // eff_midi.txt ꍇ
					// eff_midiDir
					memset(eff_midiDir, 0, eff_midiDirSize);
					if (i + strlen("\\files") >= eff_midiDirSize) break ;
					memcpy(eff_midiDir, bgmStr, i);
					strcat(eff_midiDir, "\\files");
					
					return TRUE;
				}
				break ;
			}
			
			sc ++;
			if (sc > 4) break ;
		}
	}
	memset(eff_midiDir , 0, eff_midiDirSize );
	memset(eff_midiAddr, 0, eff_midiAddrSize);
	//memset(defaultTonyuprjFileAddr, 0, defaultTonyuprjFileAddrSize);
	
	return FALSE;
}


void setMidiPlayerConfig(char *readFileName, DWORD osPlatformId, char *playerExeName, size_t playerExeNameSize) {
	int   i = 0, j;
	DWORD fileReadSize;
	int   tempInt;
	char  readBuf[BUF_SIZE_S];
	
	// ftHgݒ //////////////////////////////////////////////
	
	// OSɂMidifoCXI
	if (osPlatformId == 1) playerDirectMusicMode = 0; // 9xnłDirectMusicgȂ
	else                   playerDirectMusicMode = 1; // NTnłDirectMusicg
	playerMode      = 0; // YellowMusicPlayer[h
	playerSpeedMode = 0; // 15~bƂɓ
	playerCacheMode = 0; // LbVȂ[h
	
	////////////////////////////////////////////////////////////////
	// t@CǂݍݕύX_ݒ //
	
	fileReadSize = readFile_C(readFileName, readBuf, sizeof(readBuf) - 1, 1);
	if (fileReadSize <= 0) return ;
	
	// Player.exe ̖OςĂ鎞ÃQ[IłYellowMusicPlayer̎Iۏ؂
	// Player.exe , Tonyu.exe ̋Nł΁A̍s͎wȂŌ\
	getLinePoint(readBuf, fileReadSize, &i);
	if (i < (int)playerExeNameSize) memcpy(playerExeName, readBuf, i);
	i+=2; j=i;
	
	if (i >= (int)fileReadSize) return ;
	getLinePoint(readBuf, fileReadSize, &i);
	tempInt = strToInt(readBuf, j, i, -1); i+=2; j=i;
	if      (tempInt == 1) playerDirectMusicMode = 1; // SĂOSDirectMusicg
	else if (tempInt == 2) playerDirectMusicMode = 0; // SĂOSDirectMusicgȂ
	
	if (i >= (int)fileReadSize) return ;
	getLinePoint(readBuf, fileReadSize, &i);
	tempInt = strToInt(readBuf, j, i, -1); i+=2; j=i;
	if      (tempInt == 1) playerMode = 1; // TonyuMidiLitest[h
	else if (tempInt == 2) playerMode = 2; // MidiOggPlayer[h
	else if (tempInt == 3) playerMode = 3; // TonyuOgg Vorbis炷Tv [h
	
	if (i >= (int)fileReadSize) return ;
	getLinePoint(readBuf, fileReadSize, &i);
	tempInt = strToInt(readBuf, j, i, -1); i+=2; j=i;
	if (tempInt <   0) tempInt =   0;
	if (tempInt > 100) tempInt = 100;
	playerSpeedMode = tempInt; // playerSpeedMode*15~bƂɓ
	
	if (i >= (int)fileReadSize) return ;
	getLinePoint(readBuf, fileReadSize, &i);
	tempInt = strToInt(readBuf, j, i, -1); //i+=2; j=i;
	if (tempInt == 1) playerCacheMode = 1; // LbV胂[h
	
}


// DirectMusic[hŎgDLSt@Cǂݍ
void readMidiDls() {
	HANDLE hSearch;
	WIN32_FIND_DATA fd;
	char fileName[FILEPATH_SIZE];
	
	// t@C
	hSearch = FindFirstFile(".\\Usr\\files\\dls\\*.dls", &fd);
	if(hSearch == INVALID_HANDLE_VALUE) {
		return ;
	}
	
	while(TRUE) {
		if (strlen(".\\Usr\\files\\dls\\") + strlen(fd.cFileName) >= sizeof(fileName)) { // obt@ɓȂ
			goto FindNextFileLabel;
		} else { // 
			memset(fileName, 0, sizeof(fileName));
			memcpy(fileName, ".\\Usr\\files\\dls\\", strlen(".\\Usr\\files\\dls\\"));
			strcat(fileName, fd.cFileName);
		}
		
		// DLSt@Cǂݍ
		GGS4AddDlsA(fileName);
		
		FindNextFileLabel:
		if(!FindNextFile(hSearch, &fd)) break ;
	}
	FindClose(hSearch);
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


DWORD readFile_C(LPCTSTR fileName, char *readBuf, DWORD readBufSize, int share) {
	static HANDLE hFile;
	static BOOL   hdError;
	static DWORD  dwFileReadSize;
	
	// t@CI[v(sig)
	hFile = CreateFile(fileName, GENERIC_READ, (FILE_SHARE_READ | FILE_SHARE_WRITE)*share, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) return 0; // nhG[
	
	dwFileReadSize = GetFileSize(hFile, NULL);
	if (dwFileReadSize == 0 || dwFileReadSize == (DWORD)0xFFFFFFFF) {
		CloseHandle(hFile);
		return 0; // t@CTCY0܂̓G[
	}
	
	// obt@
	memset(readBuf, 0, readBufSize);
	
	// t@Cǂݍ
	hdError = ReadFile(hFile, readBuf, readBufSize, &dwFileReadSize, NULL);
	CloseHandle(hFile);
	if (hdError == 0) return 0; // ǂݍ݃G[
	
	return dwFileReadSize;
}


DWORD writeFile_C(LPCTSTR fileName, char *writeBuf, DWORD writeBufSize, int share) {
	static HANDLE hFile;
	static BOOL   hdError;
	static DWORD  dwFileWriteSize;
	
	// t@CI[v(sig)
	hFile = CreateFile(fileName, GENERIC_WRITE, (FILE_SHARE_READ)*share, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) return 0; // nhG[
	
	// t@C
	hdError = WriteFile(hFile, writeBuf, writeBufSize, &dwFileWriteSize, NULL);
	CloseHandle(hFile);
	if (hdError == 0) return 0;
	
	return dwFileWriteSize;
}


BOOL fileAddrToDir(char *fileAddr, char *fileDir, size_t fileDirSize) {
	int i , len;
	
	if (fileAddr[0] == '\0') return FALSE;
	
	len = strlen(fileAddr);
	for (i = len - 1; i >= 0; i--) {
		if (fileAddr[i] == '\\') break ;
	}
	if (i == -1) return FALSE;
	
	memset(fileDir, 0, fileDirSize);
	memcpy(fileDir, fileAddr, i);
	
	return TRUE;
}


int strToInt(char *str, int start, int end, int falseReturnValue) {
	char wkStr[16];
	int  i, zero = 1;
	int  ans;
	
	if (end - start >= sizeof(wkStr) - 1) end = start + sizeof(wkStr) - 2;
	memset(wkStr, 0, sizeof(wkStr));
	memcpy(wkStr, str + start, end - start);
	
	for (i = 0; i < end - start; i++) { // 0ƁAstoi()ϊłȂɕԂ0 
		if (wkStr[i] != '0') { zero = 0; break ; }
	}
	if (start == end) zero = 0; // 񂪖͗O
	
	if (zero) {
		ans = 0; // 0
	} else {
		wkStr[sizeof(wkStr) - 1] = '\0';
		ans = atoi(wkStr);
		if (ans == 0) ans = falseReturnValue; // 0͗ÖӖȂ̂ŁAG[l(faluseReturnValue)Ԃ
	}
	
	return ans;
}


double strToDouble(char *str, int start, int end, double falseReturnValue) {
	char wkStr[32];
	int  i, zero = 1;
	double ans;
	 
	if (end - start >= sizeof(wkStr) - 1) end = start + sizeof(wkStr) - 2;
	memset(wkStr, 0, sizeof(wkStr));
	memcpy(wkStr, str + start, end - start);
	
	for (i = 0; i < end - start; i++) { // 0.0ƁAstoi()ϊłȂɕԂ0.0 
		if (wkStr[i] != '0') { zero = 0; break ; }
	}
	if (start == end) zero = 0; // 񂪖͗O
	
	if (zero) {
		ans = 0.0; // 0.0
	} else {
		wkStr[sizeof(wkStr) - 1] = '\0';
		ans = atof(wkStr);
		if (ans == 0.0) ans = falseReturnValue; // 0͗ÖӖȂ̂ŁAG[l(faluseReturnValue)Ԃ
	}
	
	return ans;
}


int getLinePoint(char *str, int strSize, int *point) {
	int i;
	
	for (i = *point; i < strSize; i++) { // s̈ʒu𒲂ׂ
		if ((str[i] == '\r' && str[i+1] == '\n') || (str[i] == '\0')) break ;
	}
	
	*point = i;
	
	return i;
}

char *getMemSearch(char *str1, int size1, char *str2) {
	char *p = NULL;
	int i, j, size2;
	
	size2 = strlen(str2);
	for (i = 0; i < size1; i++) {
		for (j = size2 - 1; j >= 0; j--) {
			if (j == 0) {
				p = str1 + i;
				goto loopEnd;
			}
			if (str1[i + j] != str2[j]) break ;
		}
	}
	
	loopEnd:
	return p;
}



/*
߂l -1: G[
0 : vZX݂Ȃ
0,-1ȊO: vZXID
*/
DWORD searchProcess(LPTSTR lpszFile, DWORD osPlatformId){
	HANDLE hSnapshot;
	HANDLE hProcess;
	DWORD dwProcessId;
	PROCESSENTRY32 pe;
	TCHAR fileName[FILEPATH_SIZE];
	
	hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (hSnapshot == INVALID_HANDLE_VALUE) return (-1);
	pe.dwSize = sizeof(PROCESSENTRY32);
	
	if (Process32First(hSnapshot, &pe)) {
		do {
			if (osPlatformId != 1) {
				dwProcessId = pe.th32ProcessID;
				hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessId);
				if (hProcess != NULL) {
					GetModuleFileNameExA(hProcess, NULL, (LPTSTR)fileName, FILEPATH_SIZE);
					//MessageBox(0,fileName,"test!",0);
					CloseHandle(hProcess);
					if (!lstrcmpi((LPTSTR)fileName, lpszFile)) {
						CloseHandle(hSnapshot);
						return pe.th32ProcessID;
					}
				}
			} else {
				//MessageBox(0,pe.szExeFile,"test!",0);
				if (!lstrcmpi(pe.szExeFile, lpszFile)) {
					CloseHandle(hSnapshot);
					return pe.th32ProcessID;
				}
			}
			
		} while (Process32Next(hSnapshot, &pe));
	}
	
	CloseHandle(hSnapshot);
	return (GetLastError() == ERROR_NO_MORE_FILES) ? 0 : 0xFFFFFFFF;
}


BOOL processExist(LPTSTR lpszFile, DWORD osPlatformId, DWORD dwProcessId) {
	HANDLE hProcess;
	TCHAR fileName[FILEPATH_SIZE];
	
	// TonyuŃy[WؑւƁATonyuIɎIłȂȂdl̂ŕʂ̕@ɂ
	hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessId);
	if (hProcess != NULL) {
		if (osPlatformId != 1) { // NTn
			GetModuleFileNameExA(hProcess, NULL, (LPTSTR)fileName, FILEPATH_SIZE);
			CloseHandle(hProcess);
			if (!lstrcmpi((LPTSTR)fileName, lpszFile)) return TRUE;  // t@C
			else                                       return FALSE; // t@CȂ
		} else { // 9xn
			CloseHandle(hProcess);
			return TRUE;
		}
	} else {
		return FALSE;
	}
}




void getOggPlayingTime() {
	
	oggTotalTimeInt   = (int)(oggTotalTime * 1000); // vԂintɕϊ
	
	// ݂̍ĐԂvZ
	oggPlayingTime    = (double) oggPoint / (waveFormat.nSamplesPerSec * waveFormat.nBlockAlign)
	                  + oggStartSeek                                     // 
	                  + oggBufLoopCnt * oggPlayTime                      // obt@̎
	                  + oggLoopSeek   * oggLoopCnt                       // [vn[
	                  - (oggLoopEndSeek == 0.0) * (oggTotalTime * oggLoopCnt)    // [vI[Ȃ
	                  - (oggLoopEndSeek >  0.0) * (oggLoopEndSeek * oggLoopCnt); // [vI[
	
	if (oggPlayingTime < 0.0) oggPlayingTime = 0.0;
	
	oggPlayingTimeInt = (int)(oggPlayingTime * 1000.0); // ݂̍ĐԂintɕϊ
	
	// ĐԂ傫Ȃ߂Ȃ悤
	if (oggLoopEndSeek == 0.0) {
		if (oggPlayingTimeInt >= oggTotalTimeInt) oggPlayingTimeInt = oggTotalTimeInt; // [vI[Ȃ
	} else {
		if (oggPlayingTimeInt >= (DWORD)(oggLoopEndSeek * 1000)) oggPlayingTimeInt = (DWORD)(oggLoopEndSeek * 1000); // [vI[
	}
	
	if (oggPlayingTimeInt < oggPlayingTimeInt2) oggPlayingTimeInt  = oggPlayingTimeInt2;
	else                                        oggPlayingTimeInt2 = oggPlayingTimeInt;
}





/*
BOOL playerRestart() {
	PROCESS_INFORMATION ps;
	STARTUPINFO si;
	char myExeName[FILEPATH_SIZE];
	
	memset(myExeName, 0, sizeof(myExeName));
	//memcpy(myExeName, "Kernel\\Midiplayer2.exe", strlen("Kernel\\Midiplayer2.exe"));
	GetModuleFileName(NULL, myExeName, sizeof(myExeName));
	//MessageBox(0,myExeName,0,0);
	return !!CreateProcess(myExeName, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &ps);
}
*/
